package bullets 
{
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.FP;
	import net.flashpunk.Sfx;
	import net.flashpunk.Entity;
	import worlds.LevelOne;
	/**
	 * ...
	 * @author Commanderstitch
	 */
	public class Bullet extends Entity
	{
		public const SPRITE_WIDTH:uint = 16;
		public const SPRITE_HEIGHT:uint = 16;
		public var bulletSpritemap:Spritemap = new Spritemap(Assets.ENERGYBALL, SPRITE_WIDTH, SPRITE_HEIGHT);
		public var curAnimation:String = "";
		public static var bulletspeed:uint = 3;
		public var fangle:Number = 0;
		public var radianAngle:Number = 0;
		public static var getangle:Boolean = false;
		private var firstpass:Boolean = true;
		public function Bullet(x:Number, y:Number) 
		{
			super(x, y);
			setupSpritesheet();
			graphic = bulletSpritemap;
			setHitbox(16, 16);
			type = "bullet";
			layer = -1;
			new Sfx(Assets.HEAVYBULLETSHOT).play(.9);
		}
		override public function update():void 
		{
			firstPass();
			super.update();
			bulletSpritemap.play(curAnimation);

			if (fangle > 315 && fangle <= 360) //right llower
			{
				x += bulletspeed * Math.cos(radianAngle);
				y -= bulletspeed * Math.sin(radianAngle);
				curAnimation = "right";
				//if (world is LevelOne) LevelOne(world).emit(LevelOne.GTRAIL, x, y + 10, 1);//was 8? hmmm
			}
			if (fangle >= 0 && fangle <= 45) //right upper
			{
				x += bulletspeed * Math.cos(radianAngle);
				y -= bulletspeed * Math.sin(radianAngle);
				curAnimation = "right";
				//if (world is LevelOne) LevelOne(world).emit(LevelOne.GTRAIL, x, y + 10, 1);//was 8? hmmm
			}
			if (fangle > 45 && fangle <= 135) //up
			{
				x += bulletspeed * Math.cos(radianAngle);
				y -= bulletspeed * Math.sin(radianAngle);
				curAnimation = "up";
				//if (world is LevelOne) LevelOne(world).emit(LevelOne.GTRAIL, x, y + 10, 1);//was 8? hmmm
			}
			if (fangle > 135 && fangle <= 225) //left
			{
				x += bulletspeed * Math.cos(radianAngle);
				y -= bulletspeed * Math.sin(radianAngle);
				curAnimation = "left";
				//if (world is LevelOne) LevelOne(world).emit(LevelOne.GTRAIL, x, y + 10, 1);//was 8? hmmm
			}
			if (fangle > 225 && fangle <= 315) //down
			{
				x += bulletspeed * Math.cos(radianAngle);
				y -= bulletspeed * Math.sin(radianAngle);
				curAnimation = "down";
				//if (world is LevelOne) LevelOne(world).emit(LevelOne.GTRAIL, x, y + 10, 1);//was 8? hmmm
			}
			if (collide("wall", x, y)) {
				//sound of boom
				destroy();
			}
			if (collide("enemy", x, y)) {
				//sound of boom
				destroy();
			}
		}
		public function setupSpritesheet():void
		{
			bulletSpritemap.add("right", [0, 1, 2, 1, 0, 3], 116, true);
			bulletSpritemap.add("left", [0, 1, 2, 1, 0, 3], 116, true);
			bulletSpritemap.add("up", [0, 1, 2, 1, 0, 3],116, true);
			bulletSpritemap.add("down", [0, 1, 2, 1, 0, 3], 116, true);
		}
		public function destroy():void
		{
			FP.world.add(new BlastDesitegration(this.x-45, this.y-45));
			new Sfx(Assets.BLAST_DISINTEGRATION).play();
			FP.world.remove(this);
		}
		public function firstPass():void 
		{
			if (firstpass)
			{
				firstpass = false;
				while (collide("wall", x, y)) { x++; y++; }
				if (getangle) {
					fangle = FP.angle(x, y, FP.world.mouseX-5, FP.world.mouseY-5);
					radianAngle = fangle * Math.PI / 180;
					getangle = false;
			}
			}
		}
		
	}

}