package bullets 
{
	import items.BombNonPickable;
	import items.BombPowerUp;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.FP;
	import net.flashpunk.Sfx;
	import net.flashpunk.Entity;
	import worlds.LevelOne;
	import player.PlayerOne;
	/**
	 * ...
	 * @author Commanderstitch
	 */
	public class RedBall extends Entity
	{
		public const SPRITE_WIDTH:uint = 32;
		public const SPRITE_HEIGHT:uint = 32;
		public var bulletSpritemap:Spritemap = new Spritemap(Assets.REDBALL, SPRITE_WIDTH, SPRITE_HEIGHT);
		public var curAnimation:String = "";
		public static var bulletspeed:uint = 2;
		public var fangle:Number = 0;
		public var radianAngle:Number = 0;
		public static var getangle:Boolean = false;
		private var firstpass:Boolean = true;
		public function RedBall(x:Number, y:Number) 
		{
			super(x, y);
			setupSpritesheet();
			graphic = bulletSpritemap;
			setHitbox(16, 16);
			type = "redball";
			layer = -1;
			new Sfx(Assets.REDSHOT).play(.2);
		}
		override public function update():void 
		{
			firstPass();
			super.update();
			bulletSpritemap.play(curAnimation);

			if (fangle > 315 && fangle <= 360) //right llower
			{
				x += bulletspeed * Math.cos(radianAngle);
				y -= bulletspeed * Math.sin(radianAngle);
				curAnimation = "right";
				//if (world is LevelOne) LevelOne(world).emit(LevelOne.GTRAIL, x, y + 10, 1);//was 8? hmmm
			}
			if (fangle >= 0 && fangle <= 45) //right upper
			{
				x += bulletspeed * Math.cos(radianAngle);
				y -= bulletspeed * Math.sin(radianAngle);
				curAnimation = "right";
				//if (world is LevelOne) LevelOne(world).emit(LevelOne.GTRAIL, x, y + 10, 1);//was 8? hmmm
			}
			if (fangle > 45 && fangle <= 135) //up
			{
				x += bulletspeed * Math.cos(radianAngle);
				y -= bulletspeed * Math.sin(radianAngle);
				curAnimation = "up";
				//if (world is LevelOne) LevelOne(world).emit(LevelOne.GTRAIL, x, y + 10, 1);//was 8? hmmm
			}
			if (fangle > 135 && fangle <= 225) //left
			{
				x += bulletspeed * Math.cos(radianAngle);
				y -= bulletspeed * Math.sin(radianAngle);
				curAnimation = "left";
				//if (world is LevelOne) LevelOne(world).emit(LevelOne.GTRAIL, x, y + 10, 1);//was 8? hmmm
			}
			if (fangle > 225 && fangle <= 315) //down
			{
				x += bulletspeed * Math.cos(radianAngle);
				y -= bulletspeed * Math.sin(radianAngle);
				curAnimation = "down";
				//if (world is LevelOne) LevelOne(world).emit(LevelOne.GTRAIL, x, y + 10, 1);//was 8? hmmm
			}
			if (collide("wall", x, y)) {
				destroy();
			}
			if (collide("enemy", x, y)) {
				destroy();
			}
			if (collide("explosion", x, y)) {
				destroy();
			}
			if (collide("bombpowerup", x, y)) {
				destroy();
			}
			var s:BombPowerUp = collide("bombpowerup", x, y) as BombPowerUp;
			if (s) {
				new Sfx(Assets.EXPLOSIONSOUND).play();
				s.destroy();
				destroy();
			}
			var ss:BombNonPickable = collide("bombpowerup", x, y) as BombNonPickable;
			if (ss) {
				new Sfx(Assets.EXPLOSIONSOUND).play();
				ss.destroy();
				destroy();
			}
		}
		public function setupSpritesheet():void
		{
			bulletSpritemap.add("right", [0, 1, 2, 3, 4, 5, 6 ,7], 26, true);
			bulletSpritemap.add("left", [8, 9, 10, 11, 12, 13, 14 ,15], 26, true);
			bulletSpritemap.add("up", [0, 1, 2, 3, 4, 5, 6 ,7],26, true);
			bulletSpritemap.add("down", [8, 9, 10, 11, 12, 13, 14 ,15], 26, true);
		}
		public function destroy():void
		{
			FP.world.add(new RedBlast(this.x-45, this.y-45));
			new Sfx(Assets.REDSHOTDIE).play();
			FP.world.remove(this);
		}
		public function firstPass():void 
		{
			if (firstpass)
			{
				firstpass = false;
				while (collide("wall", x, y)) { x++; y++; }
				if (getangle) {
					fangle = FP.angle(x, y, PlayerOne.playeroneX+20, PlayerOne.playeroneY+20);
					radianAngle = fangle * Math.PI / 180;
					getangle = false;
			}
			}
		}
		
	}

}