package doors
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.FP;
	import enemies.GreenSpider;
	import net.flashpunk.Sfx;
	import player.PlayerOne;
	/**
	 * ...
	 * @author Commanderstitch
	 */
	public class RedDoor extends Entity
	{
		private const SPRITE_WIDTH:Number = 160;
		private const SPRITE_HEIGHT:Number = 48;
		public var oneSpritemap:Spritemap = new Spritemap(Assets.REDDOOR, SPRITE_WIDTH, SPRITE_HEIGHT);
		public var curAnimation:String = "ten";
		private var health:Number = 1000;
		private var tenchange:Boolean = true;
		private var ninechange:Boolean = true;
		private var eightchange:Boolean = true;
		private var sevenchange:Boolean = true;
		private var sixchange:Boolean = true;
		private var fivechange:Boolean = true;
		private var fourchange:Boolean = true;
		private var threechange:Boolean = true;
		private var twochange:Boolean = true;
		private var onechange:Boolean = true;
		
		public function RedDoor(x:Number, y:Number) 
		{
			setupSpritesheet();
			graphic = oneSpritemap;
			oneSpritemap.play(curAnimation);
			setHitbox(160, 48);
			type = "wall";
			layer = -40;
			super(x, y);
		}
		override public function update():void
		{
			super.update();
			oneSpritemap.play(curAnimation);
			if (collide("bulletred", x, y)) {
				health-=2;
				//health -= 50;//testing!
			}
			if (health <= 1000 && health >= 900) {
				curAnimation = "ten";
				if (tenchange) {tenchange = false;new Sfx(Assets.SOFTCLICK).play();}
			}
			if (health < 900 && health >= 800) {
				if (ninechange) {ninechange = false;new Sfx(Assets.DOORCRACKS).play();}
				curAnimation = "nine";
			}
			if (health < 800 && health >= 700) {
				if (eightchange) {eightchange = false;new Sfx(Assets.DOORCRACKS).play();}
				curAnimation = "eight";
			}
			if (health < 700 && health >= 600) {
				if (sevenchange) {sevenchange = false;new Sfx(Assets.DOORCRACKS).play();}
				curAnimation = "seven";
			}
			if (health < 600 && health >= 500) {
				if (sixchange) {sixchange = false;new Sfx(Assets.DOORCRACKS).play();}
				curAnimation = "six";
			}
			if (health < 500 && health >= 400) {
				if (fivechange) {fivechange = false;new Sfx(Assets.DOORCRACKS).play();}
				curAnimation = "five";
			}
			if (health < 400 && health >= 300) {
				if (fourchange) {fourchange = false;new Sfx(Assets.DOORCRACKS).play();}
				curAnimation = "four";
			}
			if (health < 300 && health >= 200) {
				if (threechange) {threechange = false;new Sfx(Assets.DOORCRACKS).play();}
				curAnimation = "three";
			}
			if (health < 200 && health >= 100) {
				if (twochange) {twochange = false;new Sfx(Assets.DOORCRACKS).play();}
				curAnimation = "two";
			}
			if (health < 100 && health >= 0) {
				if (onechange) { onechange = false;new Sfx(Assets.DOORCRACKS).play();}
				curAnimation = "one";
			}
			if (health <= 0) {
				Global.reddoor = false;
				destroy();
			}
		}
		public function setupSpritesheet():void
		{
			oneSpritemap.add("one", [9], 0, false);
			oneSpritemap.add("two", [8], 0, false);
			oneSpritemap.add("three", [7], 0, false);
			oneSpritemap.add("four", [6], 0, false);
			oneSpritemap.add("five", [5], 0, false);
			oneSpritemap.add("six", [4], 0, false);
			oneSpritemap.add("seven", [3], 0, false);
			oneSpritemap.add("eight", [2], 0, false);
			oneSpritemap.add("nine", [1], 0, false);
			oneSpritemap.add("ten", [0], 0, false);
			oneSpritemap.add("infinity", [10], 0, false);
			oneSpritemap.add("zero", [11], 0, false);
		}
		public function destroy():void
		{
			new Sfx(Assets.DOORDOWN).play();
			FP.world.remove(this);
		}
		
	}

}