package enemies 
{
	import adobe.utils.CustomActions;
	import bullets.BrownBall;
	import items.BombPowerUp;
	import items.GreenBulletPowerUp;
	import items.HealthBox;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.Sfx;
	import player.PlayerOne;
	import ui.OneThroughTen;
	import worlds.LevelOne;
	import net.flashpunk.FP;
	/**
	 * ...
	 * @author Commanderstitch
	 */
	public class BrownSpider extends Entity
	{
		public const SPRITE_WIDTH:Number = 23;
		public const SPRITE_HEIGHT:Number = 32;
		private var playerSpritemap:Spritemap = new Spritemap(Assets.BROWNSPIDER, SPRITE_WIDTH, SPRITE_HEIGHT);
		public var curAnimation:String = "stand_right";
		private var speed:Number = 5;
		private var walkspeed:Number = 5;
		private var iampaused:Boolean = false;
		private var firstpass:Boolean = true;
		private var health:Number = 9;
		private var angle:Number = 0;
		private var radius:Number = 30;
		private var timer:Number = 100;
		private var cool:Number = 100;
		private var fangle:Number = 0;
		private var radianAngle:Number = 0;
		private var getangle:Boolean = false;
		private var walktimer:Number = 10;
		private var walkrandomly:Boolean = false;
		
		private var knockbacktimer:Number = 10;
		private var knockback:Boolean = false;
		private var knockbackup:Boolean = false;
		private var knockbackdown:Boolean = false;
		private var knockbackright:Boolean = false;
		private var knockbackleft:Boolean = false;
		public static var canbehurt:Boolean = true;
		private var basepower:int = 3;
		public static var blastpower:Number = .01;
		private var firingtimer:Number = 200;
		private var getdirection:Boolean = true;
		private var wall_out_timer:Number = 50;
		private var anime_right:Boolean = false;
		private var anime_left:Boolean = false;
		private var anime_down:Boolean = false;
		private var anime_up:Boolean = false;
		private var fire_rate_timer:Number = 50;
		private var stunned:Boolean = false;
		private var stuntimer:Number = 0;
		private var addtimer:Boolean = true;
		private var deathtimer:int = 0;
		private var deathactivated:Boolean = false;
		private var onesound:Boolean = true;
		private var youritemnumber:int = 0;
		public function BrownSpider(x:Number, y:Number) 
		{
			super(x, y);
			setupSpritesheet();
			graphic = playerSpritemap;
			playerSpritemap.play(curAnimation);
			setHitbox(16, 22, -5, -10);
			type = "brownspider";
			layer = 0;
		}
		override public function update():void 
		{
			if (Global.pausegame) pauseGame();
			else playGame();
		}
		public function playGame():void
		{
			super.update();
			firstLoad();
			playerSpritemap.play(curAnimation);
			if (collide("bullet", x, y)) {
				knockback = true;
				stunned = true;
				if (addtimer) {
					addtimer = false;
					new Sfx(Assets.STUNNED_SFX).play();
					FP.world.add(new OneThroughTen(this.x, this.y));
				}
				if (stuntimer <= 0) stuntimer = 600;
				if (PlayerOne.shot_up) {
					knockbacktimer = 15;
					knockbackup = true;
					if (world is LevelOne) LevelOne(world).emit(LevelOne.HIT, x + 10, y + 20, 10);
					//health -= 5;
					resetDir();
					curAnimation = "stand_down";
				}
				if (PlayerOne.shot_right) {
					knockbacktimer = 15;
					knockbackright = true;
					if (world is LevelOne) LevelOne(world).emit(LevelOne.HIT, x + 10, y + 20, 10);
					//health -= 5;
					resetDir();
					curAnimation = "stand_left";
				}
				if (PlayerOne.shot_left) {
					knockbacktimer = 15;
					knockbackleft = true;
					if (world is LevelOne) LevelOne(world).emit(LevelOne.HIT, x + 10, y + 20, 10);
					//health -= 5;
					resetDir();
					curAnimation = "stand_right";
				}
				if (PlayerOne.shot_down) {
					knockbacktimer = 15;
					knockbackdown = true;
					if (world is LevelOne) LevelOne(world).emit(LevelOne.HIT, x + 10, y + 20, 10);
					//health -= 5;
					resetDir();
					curAnimation = "stand_up";
				}
			}
			if (knockback && knockbacktimer > 0 && !stunned) {
				if (knockbackup) {
					if (!collide("wall", x, y - (basepower + blastpower))) y -= (basepower + blastpower);
				}
				if (knockbackright) {
					if (!collide("wall", x + (basepower + blastpower), y)) x += (basepower + blastpower);
				}
				if (knockbackleft) {
					if (!collide("wall", x -(basepower + blastpower), y)) x -= (basepower + blastpower);
				}
				if (knockbackdown) {
					if (!collide("wall", x, y + (basepower + blastpower))) y += (basepower + blastpower);
				}

			}
			//now here is the movement of the or whatever it's going to be. this is the deal. I'm going to 
			//pick a random direction to go.
			//walk a few setps in the drirection.
			//get a new direction, repeat.
			//have a firing timer, when that timer is zero it overrides the movement and fires on our character.
			//reset firing timer.
			if (curAnimation == "squished"){
				//stay squished
			}
			else if (stunned) 
			{
				curAnimation = "stunned";
				type = "stunned";
			}
			else if (firingtimer <= 0)
			{
				//fire bullet anything dealing with that
				if (curAnimation == "walk_right") {
					BrownBall.getangle = true;
					FP.world.add(new BrownBall(this.x, this.y));
					curAnimation = "fire_right";
				}
				if (curAnimation == "walk_left") {
					BrownBall.getangle = true;
					FP.world.add(new BrownBall(this.x, this.y));
					curAnimation = "fire_left";
				}
				if (curAnimation == "walk_up") {
					BrownBall.getangle = true;
					FP.world.add(new BrownBall(this.x, this.y));
					curAnimation = "fire_up";
				}
				if (curAnimation == "walk_down") {
					BrownBall.getangle = true;
					FP.world.add(new BrownBall(this.x, this.y));
					curAnimation = "fire_down";
				}
				rnf();
				walkrandomly = false;
			}
			else if (walktimer <= 0)
			{
				//get new direction
				walkrandomly = true;
				walktimer = 300 * Math.floor(Math.random() * 3) + 1;
				getangle = true;
			}
			else if (walkrandomly && !collide("wall", x, y)) {
				if (getangle) {
					speed = Math.floor(Math.random() * .5) + .2;
					fangle = Math.floor(Math.random() * 360) + 1;
					radianAngle = fangle * Math.PI / 180;
					getangle = false;
				}
				if (fangle > 315 && fangle <= 360)//right lower
				{
					x += speed * Math.cos(radianAngle);
					y -= speed * Math.sin(radianAngle);
					curAnimation = "walk_right";
				}
				if (fangle >= 0 && fangle <= 45)//right uppper
				{
					x += speed * Math.cos(radianAngle);
					y -= speed * Math.sin(radianAngle);
					curAnimation = "walk_right";
				}
				if (fangle > 45 && fangle <= 135)//up
				{
					x += speed * Math.cos(radianAngle);
					y -= speed * Math.sin(radianAngle);
					curAnimation = "walk_up";
				}
				if (fangle > 135 && fangle <= 225)//left
				{
					x += speed * Math.cos(radianAngle);
					y += speed * Math.sin(radianAngle);
					curAnimation = "walk_left";
				}
				if (fangle > 225 && fangle <= 315)//down
				{
					x += speed * Math.cos(radianAngle);
					y -= speed * Math.sin(radianAngle);
					curAnimation = "walk_down";
				}
			}
			else if (walkrandomly && collide("wall", x, y) && getdirection) {
					getdirection = false;
					wall_out_timer = 100;
					if (curAnimation == "walk_right") anime_right = true;
					if (curAnimation == "walk_left") anime_left = true;
					if (curAnimation == "walk_down") anime_down = true;
					if (curAnimation == "walk_up") anime_up = true;
			}
			else if (walkrandomly && collide("wall", x,y)) {		
				if (anime_left)// so go right
				{
					fangle = 315;
					radianAngle = fangle * Math.PI / 180;
					x += speed * Math.cos(radianAngle);
					y -= speed * Math.sin(radianAngle);
					curAnimation = "walk_right";
				}
				if (anime_down)//so go up
				{
					fangle = 45;
					radianAngle = fangle * Math.PI / 180;
					x += speed * Math.cos(radianAngle);
					y -= speed * Math.sin(radianAngle);
					curAnimation = "walk_up";
				}
				if (anime_right)// so go left
				{
					fangle = 135;
					radianAngle = fangle * Math.PI / 180;
					x += speed * Math.cos(radianAngle);
					y += speed * Math.sin(radianAngle);
					curAnimation = "walk_left";
				}
				if (anime_up)// so go down
				{
					fangle = 225;
					radianAngle = fangle * Math.PI / 180;
					x += speed * Math.cos(radianAngle);
					y -= speed * Math.sin(radianAngle);
					curAnimation = "walk_down";
				}
			}
			if (stuntimer <= 0) {
				addtimer = true;
				stunned = false;
				type = "brownspider";
			}
			if (knockbacktimer <= 0) {
				knockback = false;
				knockbackup = false;
				knockbackdown = false;
				knockbackright = false;
				knockbackleft = false;
			}
			if (walktimer >= 0) walktimer--;
			if (collide("wall", x, y)) {
			}
			blastpower = Global.money * .01;
			if (stuntimer > 0) {
				stuntimer--;
			}
			if (deathactivated && deathtimer > 0) deathtimer--;
			if (knockbacktimer > 0) knockbacktimer--;
			if (firingtimer > 0) firingtimer--;
			if (wall_out_timer > 0) wall_out_timer--;
			if (wall_out_timer <= 0) {
				anime_down = false;
				anime_left = false;
				anime_right = false;
				anime_up = false;
				wall_out_timer = 500;
				getdirection = true;
			}
			if (x < 0 || y < 0 || x > 1472 || y > 960) destroy();
			if (deathactivated && deathtimer <= 0) {
				destroy();
			}
		}
		public function setupSpritesheet():void
		{
			playerSpritemap.add("walk_down", [0, 1, 2, 3], walkspeed, true);
			playerSpritemap.add("walk_up", [13, 12, 11, 10], walkspeed, true);
			playerSpritemap.add("walk_right", [0, 1, 2, 3], walkspeed, true);
			playerSpritemap.add("walk_left", [13, 12, 11, 10], walkspeed, true);
			playerSpritemap.add("stand_down", [0], 0, false);
			playerSpritemap.add("stand_up", [13], 0, false);
			playerSpritemap.add("stand_right", [0], 0, false);
			playerSpritemap.add("stand_left", [13], 0, false);
			playerSpritemap.add("fire_down", [4, 5], 3, false);
			playerSpritemap.add("fire_up", [9,8], 3, false);
			playerSpritemap.add("fire_right", [4,5], 3, false);
			playerSpritemap.add("fire_left", [9, 8], 3, false);
			playerSpritemap.add("stunned", [6, 7, 14, 7], 5, true);
			playerSpritemap.add("squished", [15], 0, false);
		}
		public function destroy():void
		{
			/*var f:DeathParticle;
			for (var b:int = 0; b <1; b++) {
				var r:int  = Math.floor(Math.random() * 30) + 1;
				if (world is LevelOne) LevelOne(world).emit(LevelOne.EXPLOSION, x+10+r, y+20+r, 10);
				f = DeathParticle(FP.world.add(new DeathParticle(this.x + 10 + r, this.y + 20 + r)));
			}*/
			//add new coin and object for this character
			//sound of death
			rid();
			if (youritemnumber == 1) FP.world.add(new HealthBox(this.x, this.y));
			else if (youritemnumber == 2) FP.world.add(new BombPowerUp(this.x, this.y));
			else if (youritemnumber == 3) FP.world.add(new GreenBulletPowerUp(this.x, this.y));
			var o:OneThroughTen = collide("onethroughten", x, y) as OneThroughTen;
			if (o) o.destroy();
			FP.world.remove(this);
		}
		public function hitpersondeath():void
		{
			/*var f:DeathParticle;
			for (var b:int = 0; b <1; b++) {
				var r:int  = Math.floor(Math.random() * 30) + 1;
				if (world is LevelOne) LevelOne(world).emit(LevelOne.EXPLOSION, x+10+r, y+20+r, 10);
				f = DeathParticle(FP.world.add(new DeathParticle(this.x + 10 + r, this.y + 20 + r)));
			}*/
			//add new coin and object for this character
			//sound of death
			FP.world.remove(this);
		}
		public function pauseGame():void
		{
			if (iampaused) {
				iampaused = false; 
			}
		}
		public function firstLoad():void 
		{
			if (firstpass) {
				firstpass = false;
				while (collide("wall", x, y)) {
					x++; y++;
				}
				rnf();
			}
		}
		public function resetDir():void
		{
			PlayerOne.shot_up = false;
			PlayerOne.shot_right = false;
			PlayerOne.shot_left = false;
			PlayerOne.shot_down = false;
		}
		public function rnf():int
		{
			return firingtimer = Math.floor(Math.random() * 1000) + 500;
		}
		public function youAreStunned():void
		{
			if (onesound) {
				onesound = false;
				new Sfx(Assets.SPLAT).play(2);
			}
			curAnimation = "squished";
			deathactivated = true;
			deathtimer = 300;
		}
		public function rid():int
		{
			return youritemnumber = Math.floor(Math.random() * 3) +1;
		}
	}

}