package items 
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.FP;
	import ui.OneThroughTen;
	import bomb.Explosion;
	import net.flashpunk.Sfx;
	import player.PlayerOne;
	/**
	 * ...
	 * @author Commanderstitch
	 */
	public class BombNonPickable extends Entity
	{
		public var itemSpritemap:Spritemap = new Spritemap(Assets.BOMBPOWERUP, 16, 16);
		public var curAnimation:String = "main";
		public var deathtimer:Number = 600;
		public function BombNonPickable(x:Number, y:Number)
		{
			super(x, y);
			setupSpritesheet();
			graphic = itemSpritemap;
			itemSpritemap.play(curAnimation);
			type = "bombpowerup";
			setHitbox(16, 16);
			FP.world.add(new OneThroughTen(this.x-5, this.y-5));
		}
		override public function update():void 
		{
			super.update();
			//doin't know if i need this actually
			if (deathtimer <= 0) destroy();
			if (deathtimer > 0) deathtimer--;
			if (collide("greenspider", x, y)) destroy();
		}
		public function setupSpritesheet():void
		{
			itemSpritemap.add("main", [0, 1, 0, 2], 4, true);
		}
		public function destroy():void
		{
			var o:OneThroughTen = collide("onethroughten", x, y) as OneThroughTen;
			if (o) o.destroy();
			FP.world.add(new Explosion(this.x-50, this.y-50));
			FP.world.add(new Explosion(this.x-50, this.y-50));
			FP.world.add(new Explosion(this.x-50, this.y-50));
			FP.world.add(new Explosion(this.x - 50, this.y - 50));
			new Sfx(Assets.EXPLOSIONSOUND).play(.7);
			FP.world.remove(this);
		}
		public function obtain():void
		{
			var o:OneThroughTen = collide("onethroughten", x, y) as OneThroughTen;
			if (o) o.destroy();
			new Sfx(Assets.POWERUP).play(2);
			FP.world.remove(this);
		}
		
	}

}