package player 
{
	import bomb.Explosion;
	import bullets.BulletGreen;
	import bullets.BulletBlue;
	import bullets.BulletBrown;
	import bullets.BulletRed;
	import items.BombNonPickable;
	import bullets.Bullet;
	import bullets.SlimeBall;
	import bullets.RedBall;
	import bullets.BlueBall;
	import bullets.BrownBall;
	import flash.geom.Point;
	import items.BombPowerUp;
	import items.GreenBulletPowerUp;
	import items.RedBulletPowerUp;
	import items.BlueBulletPowerUp;
	import items.BrownBulletPowerUp;
	import items.HealthBox;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.Sfx;
	import net.flashpunk.utils.*;
	import ui.OneThroughTenGreen;
	import ui.OneThroughTenBlue;
	import ui.OneThroughTenBrown;
	import ui.OneThroughTenRed;
	import worlds.BlueRoom;
	import worlds.BrownRoom;
	import worlds.LevelOne;
	import net.flashpunk.FP;
	import utilities.Weapon;
	import enemies.BrownSpider;
	import enemies.RedSpider;
	import enemies.BlueSpider;
	import enemies.GreenSpider;
	import ui.BulletSelect;
	import worlds.RedRoom;
	import worlds.TutorialRoom;
	/**
	 * ...
	 * @author Commanderstitch
	 */
	public class PlayerOne extends Entity
	{
		public const SPRITE_WIDTH:Number = 46;
		public const SPRITE_HEIGHT:Number = 56;
		public var playerSpritemap:Spritemap = new Spritemap(Assets.PLAYER, SPRITE_WIDTH, SPRITE_HEIGHT);
		public var curAnimation:String = "stand_down";
		public static var speed:Number = 2;
		private var helperspeed:Number = 4;
		public var walkspeed:Number = 8;
		private const UPPERLEFT:Point = new Point(0, 0);
		private const UPPERRIGHT:Point = new Point(1472, 0);//chekck#;s
		private const BOTTOMLEFT:Point = new Point(0, 960);//may need to check these #'s...
		private const BOTTOMRIGHT:Point = new Point(1472, 960);//may need to check these #'s...
		private var currentposition:Point = new Point(0, 0);
		private var currentmouse:Point = new Point(0, 0);
		private var v:Number = 0;
		private var u:Number = 0;
		private var w:Number = 0;
		private var v0:Vector.<Point> = new Vector.<Point>(0, 0);
		private var v1:Vector.<Point> = new Vector.<Point>(0, 0);
		private var v2:Vector.<Point> = new Vector.<Point>(0, 0);
		private var v3:Point = new Point(0, 0);
		private var v4:Point = new Point(0, 0);
		private var v5:Point = new Point(0, 0);
		private var d00:Number = 0;
		private var d01:Number = 0;
		private var d11:Number = 0;
		private var d20:Number = 0;
		private var d21:Number = 0;
		private var denom:Number = 0;
		private var firstpass:Boolean = true;
		public var pausegame:Boolean = false;
		private var iampaused:Boolean = true;
		public static var health:int = 1000;
		public static var shot_up:Boolean = false;
		public static var shot_down:Boolean = false;
		public static var shot_right:Boolean = false;
		public static var shot_left:Boolean = false;
		private var bullet_is_ready:Boolean = true;
		private var bullet_timer:Number = 50;
		public static var playeroneX:Number = 0;
		public static var playeroneY:Number = 0;
		private var times3:uint = 3;
		public static var squished:Boolean = false;
		private var onesound:Boolean = true;
		private var testtoggle:Boolean = true;
		public static var greenclip:Number = 0;
		public static var redclip:Number = 0;
		public static var blueclip:Number = 0;
		public static var brownclip:Number = 0;
		public static var bombclip:Number = 0;
		public static var bulletyellow:Boolean = true;
		public static var bulletgreen:Boolean = false;
		public static var bulletred:Boolean = false;
		public static var bulletblue:Boolean = false;
		public static var bulletbrown:Boolean = false;
		public static var greenclipready:Boolean = true;
		public static var redclipready:Boolean = true;
		public static var blueclipready:Boolean = true;
		public static var brownclipready:Boolean = true;
		private var redclipactivation:Boolean = true;
		private var brownclipactivation:Boolean = true;
		private var blueclipactivation:Boolean = true;
		
		public function PlayerOne(x:Number, y:Number) 
		{
			super(x, y);
			setupSpritesheet();
			graphic = playerSpritemap;
			Input.define("walk_up", Key.W, Key.UP);
			Input.define("walk_down", Key.S, Key.DOWN);
			Input.define("walk_left", Key.A, Key.LEFT);
			Input.define("walk_right", Key.D, Key.RIGHT);
			Input.define("speed_adjust", Key.P);
			Input.define("switch_armed_to_unarmed", Key.E);
			Input.define("drop_bomb", Key.Q);
			setHitbox(23, 10, -10, -25);
			type = "playerone";
			layer = -1;
		}
		override public function update():void 
		{
			if (Global.pausegame) pausePlayer();
			else playGame();
		}
		public function playGame():void
		{
			playeroneX = x;
			playeroneY = y;
			if (walkspeed != helperspeed)
					setupSpritesheet();
			super.update();
			setWalkspeed();
			setupCorrectHitBox();
			iampaused = true;
			firstLoad();
			currentposition = new Point(x, y);
			currentmouse = new Point(FP.world.mouseX, FP.world.mouseY);
			playerSpritemap.play(curAnimation);
			if (Input.pressed("switch_armed_to_unarmed"))
			{
				if (testtoggle) {
					new Sfx(Assets.SWITCHMODES).play();
					testtoggle = false;
					Weapon.cannon = true;
					Weapon.unarmed = false;
				}
				else {
					new Sfx(Assets.SWITCHMODES).play();
					testtoggle = true;
					Weapon.cannon = false;
					Weapon.unarmed = true;
				}
			}
			if (Input.pressed("drop_bomb")) {
				if (bombclip > 0) {
					new Sfx(Assets.DROPBOMB).play();
					FP.world.add(new BombNonPickable(this.x+20, this.y+20));
					//FP.world.add(new BombPowerUp(this.x, this.y));
					bombclip--;
				}
				else if (bombclip <= 0) new Sfx(Assets.OUTOFAMMO).play();
			}
			var horizontalMovement:Boolean = true;
			var verticalMovement:Boolean = true;
			if (Input.check("walk_left"))
			{
				if (collide("wall", x - speed, y))
					x -= 0;
				else
				{
					x -= speed;
					if (Input.mouseDown && !Input.check("walk_up") && !Input.check("walk_down"))
						checkShootingquadrant();
					else
						checkForWhichAnimationLeft();
				}
			}
			else if (Input.check("walk_right"))
			{
				if (collide("wall", x + speed, y))
				x += 0;
				else {
					x += speed;
					if (Input.mouseDown && !Input.check("walk_up") && !Input.check("walk_down"))
						checkShootingquadrant();
					else
						checkForWhichAnimationRight();
				}
			}
			else
				horizontalMovement = false;
			if (Input.check("walk_up"))
			{
				if (collide("wall", x, y - speed))
					y -= 0;
				else
				{
					y -= speed;
					if (Input.mouseDown)
						checkShootingquadrant();
					else
						checkForWhichAnimationUp();
				}
			}
			else if (Input.check("walk_down"))
			{
				if (collide("wall", x, y + speed))
					y += 0;
				else
				{
					y += speed;
					if (Input.mouseDown)
						checkShootingquadrant();
					else
						checkForWhichAnimationDown();
				}
			}
			else
				verticalMovement = false;
			if (!verticalMovement && !horizontalMovement) {
				shot_down = false; shot_up = false; shot_right = false; shot_left = false;
				if (Input.mouseDown)
					checkShootingquadrant();
				else switch(curAnimation)
				{
					case "walk_left":curAnimation = "stand_left";break;
					case "walk_right":curAnimation = "stand_right";break;
					case "walk_up":curAnimation = "stand_up";break;
					case "walk_down":curAnimation = "stand_down";break;
					case "fire_left":curAnimation = "firestand_left";break;
					case "fire_right":curAnimation = "firestand_right";break;
					case "fire_up":curAnimation = "firestand_up";break;
					case "fire_down":curAnimation = "firestand_down";break;
				}
			}
			if (Weapon.unarmed)
			var r:GreenSpider = collide("stunned", x, y) as GreenSpider;
			if (r && Weapon.unarmed)
			{
				if (Input.mousePressed) {
					curAnimation = "stomp";
					new Sfx(Assets.HORSENEIGH).play(2);
				}
				if (curAnimation == "stomp" && playerSpritemap.complete) r.youAreStunned();
			}
			var redr:RedSpider = collide("stunned", x, y) as RedSpider;
			if (redr && Weapon.unarmed)
			{
				if (Input.mousePressed) {
					curAnimation = "stomp";
					new Sfx(Assets.HORSENEIGH).play(2);
				}
				if (curAnimation == "stomp" && playerSpritemap.complete) redr.youAreStunned();
			}
			var brownr:BrownSpider = collide("stunned", x, y) as BrownSpider;
			if (brownr && Weapon.unarmed)
			{
				if (Input.mousePressed) {
					curAnimation = "stomp";
					new Sfx(Assets.HORSENEIGH).play(2);
				}
				if (curAnimation == "stomp" && playerSpritemap.complete) brownr.youAreStunned();
			}
			var bluer:BlueSpider = collide("stunned", x, y) as BlueSpider;
			if (bluer && Weapon.unarmed)
			{
				if (Input.mousePressed) {
					curAnimation = "stomp";
					new Sfx(Assets.HORSENEIGH).play(2);
				}
				if (curAnimation == "stomp" && playerSpritemap.complete) bluer.youAreStunned();
			}
			if (collide("wall", x, y)) {
				trace("you should never see this message, but! i'm stuck in a wall and can't get out save me pleaaaaaaaaaaaaaaaaaaaaaaase!!!!!"); x += 0; y += 0;
			}
			var s:SlimeBall = collide("slimeball", x, y) as SlimeBall;
			if (s) {
				new Sfx(Assets.OW).play();
				s.destroy();
				health -= 50;
			}
			var rrrrs:RedBall = collide("redball", x, y) as RedBall;
			if (rrrrs) {
				new Sfx(Assets.OW).play();
				rrrrs.destroy();
				health -= 50;
			}
			var bbbbs:BrownBall = collide("brownball", x, y) as BrownBall;
			if (bbbbs) {
				new Sfx(Assets.OW).play();
				bbbbs.destroy();
				health -= 50;
			}
			var bllls:BlueBall = collide("blueball", x, y) as BlueBall;
			if (bllls) {
				new Sfx(Assets.OW).play();
				bllls.destroy();
				health -= 50;
			}
			var gs:GreenSpider = collide("greenspider", x, y) as GreenSpider;
			if (gs) {
				new Sfx(Assets.OW).play();
				gs.hitpersondeath();
				health -= 50;
			}
			var rrs:RedSpider = collide("redspider", x, y) as RedSpider;
			if (rrs) {
				trace("i'm hitting the redspider!");
				new Sfx(Assets.OW).play();
				rrs.hitpersondeath();
				health -= 50;
			}
			var bbs:BrownSpider = collide("brownspider", x, y) as BrownSpider;
			if (bbs) {
				new Sfx(Assets.OW).play();
				bbs.hitpersondeath();
				health -= 50;
			}
			var bls:BlueSpider = collide("bluespider", x, y) as BlueSpider;
			if (bls) {
				new Sfx(Assets.OW).play();
				bls.hitpersondeath();
				health -= 50;
			}
			var h:HealthBox = collide("healthbox", x, y) as HealthBox;
			if (h) {
				new Sfx(Assets.POWERUP).play(2);
				health += 100;
				h.destroy();
			}
			var gp:GreenBulletPowerUp = collide("greenbulletpowerup", x, y) as GreenBulletPowerUp;
			if (gp) {
				new Sfx(Assets.HORSEBRBRBR).play(2);
				if (onesound) {
					onesound = false;
					BulletSelect.clips += 100;
				}
				if (greenclip < 10) greenclip++;
				gp.destroy();
			}
			var rp:RedBulletPowerUp = collide("redbulletpowerup", x, y) as RedBulletPowerUp;
			if (rp) {
				new Sfx(Assets.HORSEBRBRBR).play(2);
				if (redclipactivation) {
					redclipactivation = false;
					BulletSelect.clips += 100;
				}
				if (redclip < 10) redclip++;
				rp.destroy();
			}
			var bp:BlueBulletPowerUp = collide("bluebulletpowerup", x, y) as BlueBulletPowerUp;
			if (bp) {
				new Sfx(Assets.HORSEBRBRBR).play(2);
				if (blueclipactivation) {
					blueclipactivation = false;
					BulletSelect.clips += 100;
				}
				if (blueclip < 10) blueclip++;
				bp.destroy();
			}
			var brp:BrownBulletPowerUp = collide("brownbulletpowerup", x, y) as BrownBulletPowerUp;
			if (brp) {
				new Sfx(Assets.HORSEBRBRBR).play(2);
				if (brownclipactivation) {
					brownclipactivation = false;
					BulletSelect.clips += 100;
				}
				if (brownclip < 10) brownclip++;
				brp.destroy();
			}
			if (health <= 0) {
				new Sfx(Assets.HORSEDEATH).play();
				destroy();
				//load the menu
			}
			if (bullet_timer > 0) bullet_timer--;
			if (bullet_timer <= 0) {
				bullet_is_ready = true;
				bullet_timer = 10;
			}
			if (world is LevelOne && this.x < -5) {
				//load tutorial?
				trace("load tutorial");
				FP.world = new TutorialRoom;
			}
			if (world is LevelOne && this.y < -5) {
				//load redroom
				trace("load RedRoom");
				FP.world = new RedRoom;
			}
			if (world is LevelOne && this.y > 950) {
				//load brownroom
				trace("load BrownRoom");
				FP.world = new BrownRoom;
			}
			if (world is LevelOne && this.x > 1456) {
				//load blue room
				trace("load BlueRoom");
				FP.world = new BlueRoom;
			}
			if (world is RedRoom && this.x < -5) {
			}
			if (world is RedRoom && this.y < -5) {
			}
			if (world is RedRoom && this.y > 950) {
				FP.world = new LevelOne;
			}
			if (world is RedRoom && this.x > 1456) {
			}
			if (world is BrownRoom && this.x < -5) {
			}
			if (world is BrownRoom && this.y < -5) {
				FP.world = new LevelOne;
			}
			if (world is BrownRoom && this.y > 950) {
			}
			if (world is BrownRoom && this.x > 1456) {
			}
			if (world is TutorialRoom && this.x < -5) {
			}
			if (world is TutorialRoom && this.y < -5) {
			}
			if (world is TutorialRoom && this.y > 950) {
			}
			if (world is TutorialRoom && this.x > 1456) {
				FP.world = new LevelOne;
			}
			if (world is BlueRoom && this.x < -5) {
				FP.world = new LevelOne;
			}
			if (world is BlueRoom && this.y < -5) {
			}
			if (world is BlueRoom && this.y > 950) {
			}
			if (world is BlueRoom && this.x > 1456) {
			}
		}
		public function setupSpritesheet():void
		{
			playerSpritemap.add("walk_down", [0, 1, 2, 1], walkspeed, true);
			playerSpritemap.add("walk_up", [8, 9, 10, 9], walkspeed, true);
			playerSpritemap.add("walk_right", [16, 17, 18, 19], walkspeed, true);
			playerSpritemap.add("walk_left", [24, 25, 26, 27], walkspeed, true);
			playerSpritemap.add("stand_down", [0], 0, false);
			playerSpritemap.add("stand_up", [8], 0, false);
			playerSpritemap.add("stand_right", [16], 0, false);
			playerSpritemap.add("stand_left", [24], 0, false);
			playerSpritemap.add("fire_down", [3, 4, 5, 4], walkspeed, true);
			playerSpritemap.add("fire_up", [11, 12, 13, 12], walkspeed, true);
			playerSpritemap.add("fire_right", [20, 21, 22, 23], walkspeed, true);
			playerSpritemap.add("fire_left", [28, 29, 30, 31], walkspeed, true);
			playerSpritemap.add("firestand_down", [3], 0 , false);
			playerSpritemap.add("firestand_up", [11], 0, false);
			playerSpritemap.add("firestand_right", [20], 0, false);
			playerSpritemap.add("firestand_left", [28], 0 , false);
			playerSpritemap.add("stomp", [6, 7, 14, 15], 6, false);
		}
		public function setupCorrectHitBox():void {
			if (curAnimation == "walk_down" || curAnimation == "stand_down" || curAnimation == "fire_down" || curAnimation == "firestand_down") setHitbox(10, 11, -18, -25);
			if (curAnimation == "walk_up" || curAnimation == "stand_up" || curAnimation == "fire_up" || curAnimation == "firestand_up") setHitbox(9, 11, -18, -25);
			if (curAnimation == "walk_right" || curAnimation == "stand_right" || curAnimation == "fire_right" || curAnimation == "firestand_right" || curAnimation == "stomp"
				|| curAnimation == "walk_left" || curAnimation == "stand_left" || curAnimation == "fire_left" || curAnimation == "firestand_left") setHitbox(11, 10, -16, -25);
			//down: setHitbox(10, 21, -18, -16);
			//up: setHitbox(9, 23, -18, -17);
			//right and left: setHitbox(23, 10, -10, -25);
		}
		public function destroy():void
		{
			/*var f:DeathParticle;
			for (var b:int = 0; b < 50; b++) {
				var r:int  = Math.floor(Math.random() * 30) + 1;
				f = DeathParticle(FP.world.add(new DeathParticle(this.x + 20 + r, this.y + 30)));
			}*/
			FP.world.add(new Explosion(this.x - 20, this.y - 20));
			FP.world.add(new Explosion(this.x - 10, this.y + 20));
			FP.world.add(new Explosion(this.x - 5, this.y - 20));
			FP.world.add(new Explosion(this.x, this.y));
			FP.world.add(new Explosion(this.x +1 , this.y - 20));
			FP.world.remove(this);
		}
		public function pausePlayer():void
		{
			if (iampaused)
			{
				iampaused = false;
				trace("you've paused the game!");
			}
		}
		public function checkShootingquadrant():void
		{
			if (isInside(currentmouse, currentposition, UPPERLEFT, UPPERRIGHT))
			{
				if (Weapon.cannon) {
					shot_up = true;
					if (bulletyellow) Bullet.getangle = true;
					if (bulletgreen) BulletGreen.getangle = true;
					if (bulletred) BulletRed.getangle = true;
					if (bulletblue) BulletBlue.getangle = true;
					if (bulletbrown) BulletBrown.getangle = true;
					curAnimation = "fire_up";
					//if you are not colliding with a wall knockback? :) maybe a tiny bit for some lot's for others
					//if (world is LevelOne) LevelOne(world).emit(LevelOne.DMISS, x + 10, y + 20, 1);
					if (bullet_is_ready) {
						bullet_is_ready = false;
						if (bulletyellow) FP.world.add(new Bullet(this.x + 15, this.y - 10));
						if (bulletgreen) {
							if (greenclipready && greenclip > 0) {
								greenclipready = false;
								FP.world.add(new OneThroughTenGreen(this.x, this.y));
							}
							FP.world.add(new BulletGreen(this.x + 15, this.y -10));
						}
						if (bulletred) {
							if (redclipready && redclip > 0) {
								redclipready = false;
								FP.world.add(new OneThroughTenRed(this.x, this.y));
							}
							FP.world.add(new BulletRed(this.x + 15, this.y -10));
						}
						if (bulletblue) {
							if (blueclipready && blueclip > 0) {
								blueclipready = false;
								FP.world.add(new OneThroughTenBlue(this.x, this.y));
							}
							FP.world.add(new BulletBlue(this.x + 15, this.y -10));
						}
						if (bulletbrown) {
							if (brownclipready && brownclip > 0) {
								brownclipready = false;
								FP.world.add(new OneThroughTenBrown(this.x, this.y));
							}
							FP.world.add(new BulletBrown(this.x + 15, this.y -10));
						}
					}
				}
			}
			else if (isInside(currentmouse, currentposition, BOTTOMLEFT, BOTTOMRIGHT))
			{
				if (Weapon.cannon) {
					shot_down = true;
					if (bulletyellow) Bullet.getangle = true;
					if (bulletgreen) BulletGreen.getangle = true;
					if (bulletred) BulletRed.getangle = true;
					if (bulletblue) BulletBlue.getangle = true;
					if (bulletbrown) BulletBrown.getangle = true;
					curAnimation = "fire_down";
					//if you are not colliding with a wall knockback? :) maybe a tiny bit for some lot's for others
					//if (world is LevelOne) LevelOne(world).emit(LevelOne.DMISS, x + 10, y + 20, 1);
					if (bullet_is_ready) {
						bullet_is_ready = false;
						if (bulletyellow) FP.world.add(new Bullet(this.x + 15, this.y + 10));
						if (bulletgreen) {
							if (greenclipready && greenclip > 0) {
								greenclipready = false;
								FP.world.add(new OneThroughTenGreen(this.x, this.y));
							}
							FP.world.add(new BulletGreen(this.x +15, this.y +10));
						}
						if (bulletred) {
							if (redclipready && redclip > 0) {
								redclipready = false;
								FP.world.add(new OneThroughTenRed(this.x, this.y));
							}
							FP.world.add(new BulletRed(this.x + 15, this.y -10));
						}
						if (bulletblue) {
							if (blueclipready && blueclip > 0) {
								blueclipready = false;
								FP.world.add(new OneThroughTenBlue(this.x, this.y));
							}
							FP.world.add(new BulletBlue(this.x + 15, this.y -10));
						}
						if (bulletbrown) {
							if (brownclipready && brownclip > 0) {
								brownclipready = false;
								FP.world.add(new OneThroughTenBrown(this.x, this.y));
							}
							FP.world.add(new BulletBrown(this.x + 15, this.y -10));
						}
					}
				}
			}
			else if (isInside(currentmouse, currentposition, UPPERLEFT, BOTTOMLEFT))
			{
				if (Weapon.cannon) {
					shot_left = true;
					if (bulletyellow) Bullet.getangle = true;
					if (bulletgreen) BulletGreen.getangle = true;
					if (bulletred) BulletRed.getangle = true;
					if (bulletblue) BulletBlue.getangle = true;
					if (bulletbrown) BulletBrown.getangle = true;
					curAnimation = "fire_left";
					//if you are not colliding with a wall knockback? :) maybe a tiny bit for some lot's for others
					//if (world is LevelOne) LevelOne(world).emit(LevelOne.DMISS, x + 10, y + 20, 1);
					if (bullet_is_ready) {
						bullet_is_ready = false;
						if (bulletyellow) FP.world.add(new Bullet(this.x - 10, this.y + 5));
						if (bulletgreen) {
							if (greenclipready && greenclip > 0) {
								greenclipready = false;
								FP.world.add(new OneThroughTenGreen(this.x, this.y));
							}
							FP.world.add(new BulletGreen(this.x - 10, this.y + 5));
						}
						if (bulletred) {
							if (redclipready && redclip > 0) {
								redclipready = false;
								FP.world.add(new OneThroughTenRed(this.x, this.y));
							}
							FP.world.add(new BulletRed(this.x - 10, this.y +5));
						}
						if (bulletblue) {
							if (blueclipready && blueclip > 0) {
								blueclipready = false;
								FP.world.add(new OneThroughTenBlue(this.x, this.y));
							}
							FP.world.add(new BulletBlue(this.x-10, this.y +5));
						}
						if (bulletbrown) {
							if (brownclipready && brownclip > 0) {
								brownclipready = false;
								FP.world.add(new OneThroughTenBrown(this.x, this.y));
							}
							FP.world.add(new BulletBrown(this.x-10, this.y +5));
						}
					}
				}
			}
			else if (isInside(currentmouse, currentposition, UPPERRIGHT, BOTTOMRIGHT))
			{
				if (Weapon.cannon) {
					shot_right = true;
					if (bulletyellow) Bullet.getangle = true;
					if (bulletgreen) BulletGreen.getangle = true;
					if (bulletred) BulletRed.getangle = true;
					if (bulletblue) BulletBlue.getangle = true;
					if (bulletbrown) BulletBrown.getangle = true;
					curAnimation = "fire_right";
					//if you are not colliding with a wall knockback? :) maybe a tiny bit for some lot's for others
					//if (world is LevelOne) LevelOne(world).emit(LevelOne.DMISS, x + 10, y + 20, 1);
					if (bullet_is_ready) {
						bullet_is_ready = false;
						if (bulletyellow) FP.world.add(new Bullet(this.x + 40, this.y + 5));
						if (bulletgreen) {
							if (greenclipready && greenclip > 0) {
								greenclipready = false;
								FP.world.add(new OneThroughTenGreen(this.x, this.y));
							}
							FP.world.add(new BulletGreen(this.x + 40, this.y + 5));
						}
						if (bulletred) {
							if (redclipready && redclip > 0) {
								redclipready = false;
								FP.world.add(new OneThroughTenRed(this.x, this.y));
							}
							FP.world.add(new BulletRed(this.x + 40, this.y + 5));
						}
						if (bulletblue) {
							if (blueclipready && blueclip > 0) {
								blueclipready = false;
								FP.world.add(new OneThroughTenBlue(this.x, this.y));
							}
							FP.world.add(new BulletBlue(this.x + 40, this.y +5));
						}
						if (bulletbrown) {
							if (brownclipready && brownclip > 0) {
								brownclipready = false;
								FP.world.add(new OneThroughTenBrown(this.x, this.y));
							}
							FP.world.add(new BulletBrown(this.x + 40, this.y +5));
						}
					}
				}
			}
		}
		public function isInside(p:Point, p1:Point, p2:Point, p3:Point):Boolean
		{
			v0.push(new Point((p3.x - p1.x), (p3.y - p1.y)));
			v1.push(new Point((p2.x - p1.x), (p2.y - p1.y)));
			v2.push(new Point((p.x - p1.x), (p.y - p1.y)));
			v3 = v0.pop();
			v4 = v1.pop();
			v5 = v2.pop();
			d00 = ((v3.x * v3.x) + (v3.y * v3.y));
			d01 = ((v3.x * v4.x) + (v3.y * v4.y));
			d11 = ((v4.x * v4.x) + (v4.y * v4.y));
			d20 = ((v5.x * v3.x) + (v5.y * v3.y));
			d21 = ((v5.x * v4.x) + (v5.y * v4.y));
			denom = 1 / (d00 * d11 - d01 * d01);
			u = (d11 * d20 - d01 * d21) * denom;
			v = (d00 * d21 - d01 * d20) * denom;
			return (u >= 0) && (v >= 0) && (u + v < 1);
		}
		public function firstLoad():void
		{
			if (firstpass)
			{
				firstpass = false;
				while (collide("wall", x, y)) { x++; y++; }
				Weapon.unarmed = true;
			}
		}
		public function setWalkspeed():void
		{
			helperspeed = walkspeed;
			walkspeed = speed + 6;
		}
		public function loadMenu():void
		{
			//load the menu
		}
		public function checkForWhichAnimationLeft():void
		{
			if (Weapon.unarmed) curAnimation = "walk_left";
			if (Weapon.cannon) curAnimation = "fire_left"; //it's the kind of gun you have... xD
		}
		public function checkForWhichAnimationRight():void
		{
			if (Weapon.unarmed) curAnimation = "walk_right";
			if (Weapon.cannon) curAnimation = "fire_right"; 
		}
		public function checkForWhichAnimationUp():void
		{
			if (Weapon.unarmed) curAnimation = "walk_up";
			if (Weapon.cannon) curAnimation = "fire_up";
		}
		public function checkForWhichAnimationDown():void
		{
			if (Weapon.unarmed) curAnimation = "walk_down";
			if (Weapon.cannon) curAnimation = "fire_down";
		}
		
	}

}