package ui 
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.FP;
	import enemies.GreenSpider;
	import net.flashpunk.Sfx;
	import player.PlayerOne;
	import net.flashpunk.utils.*;
	/**
	 * ...
	 * @author Commanderstitch
	 */
	public class BracketSelector extends Entity
	{
		private const SPRITE_WIDTH:Number = 8;
		private const SPRITE_HEIGHT:Number = 8;
		public var oneSpritemap:Spritemap = new Spritemap(Assets.BRACKETSELECTOR, SPRITE_WIDTH, SPRITE_HEIGHT);
		public var curAnimation:String = "one";
		private var rem:Boolean = false;
		private var tenchange:Boolean = false;
		private var ninechange:Boolean = false;
		private var eightchange:Boolean = false;
		private var sevenchange:Boolean = false;
		private var sixchange:Boolean = false;
		private var fivechange:Boolean = false;
		private var fourchange:Boolean = false;
		private var threechange:Boolean = false;
		private var twochange:Boolean = false;
		private var onechange:Boolean = true;
		private var _x:Number = 0;
		private var _y:Number = 0;
		public function BracketSelector(x:Number, y:Number) 
		{
			setupSpritesheet();
			graphic = oneSpritemap;
			oneSpritemap.play(curAnimation);
			setHitbox(8, 8,-10,-10);
			type = "bracketselector";
			layer = -40;
			super(x, y);
			_x = FP.camera.x+16;
			_y = FP.camera.y+232;
		}
		override public function update():void
		{
			super.update();
			oneSpritemap.play(curAnimation);
			if (onechange) {
				this.x = FP.camera.x +16;
				this.y = FP.camera.y+232;
			}
			if (twochange) {
				this.x = FP.camera.x + 24;
				this.y = FP.camera.y + 232;
			}
			if (threechange) {
				this.x = FP.camera.x + 32;
				this.y = FP.camera.y + 232;
			}
			if (fourchange) {
				this.x = FP.camera.x + 40;
				this.y = FP.camera.y + 232;
			}
			if (fivechange) {
				this.x = FP.camera.x + 48;
				this.y = FP.camera.y + 232;
			}
			if (sixchange) {
				this.x = FP.camera.x + 56;
				this.y = FP.camera.y + 232;
			}
			if (sevenchange) {
				this.x = FP.camera.x + 64;
				this.y = FP.camera.y + 232;
			}
			if (eightchange) {
				this.x = FP.camera.x + 72;
				this.y = FP.camera.y + 232;
			}
			if (ninechange) {
				this.x = FP.camera.x + 80;
				this.y = FP.camera.y + 232;
			}
			if (tenchange) {
				this.x = FP.camera.x + 88;
				this.y = FP.camera.y + 232;
			}
			if (Input.pressed(Key.DIGIT_1)) {
				trace("changed to one");
				new Sfx(Assets.SWITCHBRACKET).play();
				onechange = true;
				twochange = false;
				threechange = false;
				fourchange = false;
				fivechange = false;
				sixchange = false;
				sevenchange = false;
				eightchange = false;
				ninechange = false;
				tenchange = false;
				PlayerOne.bulletyellow = true;
				PlayerOne.bulletgreen = false;
				PlayerOne.bulletred = false;
				PlayerOne.bulletbrown = false;
				PlayerOne.bulletblue = false;
			}
			else if (Input.pressed(Key.DIGIT_2)) {
				trace("changed to 2");
				new Sfx(Assets.SWITCHBRACKET).play();
				onechange = false;
				twochange = true;
				threechange = false;
				fourchange = false;
				fivechange = false;
				sixchange = false;
				sevenchange = false;
				eightchange = false;
				ninechange = false;
				tenchange = false;
				if (PlayerOne.greenclip > 0) {
					PlayerOne.bulletyellow = false;
					PlayerOne.bulletgreen = true;
					PlayerOne.bulletred = false;
					PlayerOne.bulletbrown = false;
					PlayerOne.bulletblue = false;
				}
				else
					PlayerOne.bulletyellow = true;
			}
			else if (Input.pressed(Key.DIGIT_3)) {
				trace("changed to 3");
				new Sfx(Assets.SWITCHBRACKET).play();
				onechange = false;
				twochange = false;
				threechange = true;
				fourchange = false;
				fivechange = false;
				sixchange = false;
				sevenchange = false;
				eightchange = false;
				ninechange = false;
				tenchange = false;
				if (PlayerOne.redclip > 0) {
					PlayerOne.bulletyellow = false;
					PlayerOne.bulletgreen = false;
					PlayerOne.bulletred = true;
					PlayerOne.bulletbrown = false;
					PlayerOne.bulletblue = false;
				}
				else
					PlayerOne.bulletyellow = true;
			}
			else if (Input.pressed(Key.DIGIT_4)) {
				trace("changed to 4");
				new Sfx(Assets.SWITCHBRACKET).play();
				onechange = false;
				twochange = false;
				threechange = false;
				fourchange = true;
				fivechange = false;
				sixchange = false;
				sevenchange = false;
				eightchange = false;
				ninechange = false;
				tenchange = false;
				if (PlayerOne.blueclip > 0) {
					PlayerOne.bulletyellow = false;
					PlayerOne.bulletgreen = false;
					PlayerOne.bulletred = false;
					PlayerOne.bulletbrown = false;
					PlayerOne.bulletblue = true;
				}
				else
					PlayerOne.bulletyellow = true;
			}
			else if (Input.pressed(Key.DIGIT_5)) {
				trace("changed to 5");
				new Sfx(Assets.SWITCHBRACKET).play();
				onechange = false;
				twochange = false;
				threechange = false;
				fourchange = false;
				fivechange = true;
				sixchange = false;
				sevenchange = false;
				eightchange = false;
				ninechange = false;
				tenchange = false;
				if (PlayerOne.brownclip > 0) {
					PlayerOne.bulletyellow = false;
					PlayerOne.bulletgreen = false;
					PlayerOne.bulletred = false;
					PlayerOne.bulletbrown = true;
					PlayerOne.bulletblue = false;
				}
				else
					PlayerOne.bulletyellow = true;
			}
			else if (Input.pressed(Key.DIGIT_6)) {
				trace("changed to 6");
				new Sfx(Assets.SWITCHBRACKET).play();
				onechange = false;
				twochange = false;
				threechange = false;
				fourchange = false;
				fivechange = false;
				sixchange = true;
				sevenchange = false;
				eightchange = false;
				ninechange = false;
				tenchange = false;
			}
			else if (Input.pressed(Key.DIGIT_7)) {
				trace("changed to 7");
				new Sfx(Assets.SWITCHBRACKET).play();
				onechange = false;
				twochange = false;
				threechange = false;
				fourchange = false;
				fivechange = false;
				sixchange = false;
				sevenchange = true;
				eightchange = false;
				ninechange = false;
				tenchange = false;
			}
			else if (Input.pressed(Key.DIGIT_8)) {
				trace("changed to 8");
				new Sfx(Assets.SWITCHBRACKET).play();
				onechange = false;
				twochange = false;
				threechange = false;
				fourchange = false;
				fivechange = false;
				sixchange = false;
				sevenchange = false;
				eightchange = true;
				ninechange = false;
				tenchange = false;
			}
			else if (Input.pressed(Key.DIGIT_9)) {
				trace("changed to 9");
				new Sfx(Assets.SWITCHBRACKET).play();
				onechange = false;
				twochange = false;
				threechange = false;
				fourchange = false;
				fivechange = false;
				sixchange = false;
				sevenchange = false;
				eightchange = false;
				ninechange = true;
				tenchange = false;
			}
			else if (Input.pressed(Key.DIGIT_0)) {
				trace("changed to 10");
				new Sfx(Assets.SWITCHBRACKET).play();
				onechange = false;
				twochange = false;
				threechange = false;
				fourchange = false;
				fivechange = false;
				sixchange = false;
				sevenchange = false;
				eightchange = false;
				ninechange = false;
				tenchange = true;
			}
		}
		public function setupSpritesheet():void
		{
			oneSpritemap.add("one", [0,1,2,3,2,1], 4, true);
		}
		public function destroy():void
		{
			FP.world.remove(this);
		}
		
	}

}