package ui 
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.FP;
	import enemies.GreenSpider;
	import net.flashpunk.Sfx;
	import player.PlayerOne;
	/**
	 * ...
	 * @author Commanderstitch
	 */
	public class BulletSelect extends Entity
	{
		private const SPRITE_WIDTH:Number = 81;
		private const SPRITE_HEIGHT:Number = 8;
		public var oneSpritemap:Spritemap = new Spritemap(Assets.BULLETSELECT, SPRITE_WIDTH, SPRITE_HEIGHT);
		public var curAnimation:String = "one";
		private var rem:Boolean = false;
		private var tenchange:Boolean = true;
		private var ninechange:Boolean = true;
		private var eightchange:Boolean = true;
		private var sevenchange:Boolean = true;
		private var sixchange:Boolean = true;
		private var fivechange:Boolean = true;
		private var fourchange:Boolean = true;
		private var threechange:Boolean = true;
		private var twochange:Boolean = true;
		private var onechange:Boolean = true;
		public static var clips:Number = 0;
		public function BulletSelect(x:Number, y:Number) 
		{
			setupSpritesheet();
			graphic = oneSpritemap;
			oneSpritemap.play(curAnimation);
			setHitbox(8, 8,-10,-10);
			type = "bulletselect";
			layer = -40;
			super(x, y);
			FP.world.add(new OneThroughInfinity(this.x-20, this.y + 20, "infinity"));
		}
		override public function update():void
		{
			super.update();
			oneSpritemap.play(curAnimation);
			if (clips <= 1000 && clips >= 900) {
				curAnimation = "ten";
				if (tenchange) {tenchange = false;new Sfx(Assets.SOFTCLICK).play();}
			}
			if (clips < 900 && clips >= 800) {
				if (ninechange) {ninechange = false;new Sfx(Assets.SOFTCLICK).play();}
				curAnimation = "nine";
			}
			if (clips < 800 && clips >= 700) {
				if (eightchange) {eightchange = false;new Sfx(Assets.SOFTCLICK).play();}
				curAnimation = "eight";
			}
			if (clips < 700 && clips >= 600) {
				if (sevenchange) {sevenchange = false;new Sfx(Assets.SOFTCLICK).play();}
				curAnimation = "seven";
			}
			if (clips < 600 && clips >= 500) {
				if (sixchange) {sixchange = false;new Sfx(Assets.SOFTCLICK).play();}
				curAnimation = "six";
			}
			if (clips < 500 && clips >= 400) {
				if (fivechange) {fivechange = false; FP.world.add(new BlueClipCounter(this.x - 28, this.y - 20, "one"));}
				curAnimation = "five";
			}
			if (clips < 400 && clips >= 300) {
				if (fourchange) {fourchange = false; FP.world.add(new BrownClipCounter(this.x - 28, this.y - 20, "one"));}
				curAnimation = "four";
			}
			if (clips < 300 && clips >= 200) {
				if (threechange) {threechange = false; FP.world.add(new RedClipCounter(this.x - 28, this.y - 20, "one"));}
				curAnimation = "three";
			}
			if (clips < 200 && clips >= 100) {
				if (twochange) {twochange = false; FP.world.add(new OneThroughInfinity1(this.x - 28, this.y - 20, "one"));}
				curAnimation = "two";
			}
			if (clips < 100 && clips >= 0) {
				if (onechange) { onechange = false; FP.world.add(new OneThroughInfinity(this.x - 28, this.y - 20, "infinity")); }
				curAnimation = "one";
			}
		}
		public function setupSpritesheet():void
		{
			oneSpritemap.add("one", [0], 4, true);
			oneSpritemap.add("two", [1], 0, false);
			oneSpritemap.add("three", [2], 0, false);
			oneSpritemap.add("four", [3], 0, false);
			oneSpritemap.add("five", [4], 0, false);
			oneSpritemap.add("six", [5], 0, false);
			oneSpritemap.add("seven", [6], 0, false);
			oneSpritemap.add("eight", [7], 0, false);
			oneSpritemap.add("nine", [8], 0, false);
			oneSpritemap.add("ten", [9], 0, false);
		}
		public function destroy():void
		{
			FP.world.remove(this);
		}
		
	}

}