package ui 
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.FP;
	import enemies.GreenSpider;
	import net.flashpunk.Sfx;
	import player.PlayerOne;
	/**
	 * ...
	 * @author Commanderstitch
	 */
	public class Hearts extends Entity
	{
		private const SPRITE_WIDTH:Number = 80;
		private const SPRITE_HEIGHT:Number = 8;
		public var oneSpritemap:Spritemap = new Spritemap(Assets.HEARTS, SPRITE_WIDTH, SPRITE_HEIGHT);
		public var curAnimation:String = "ten";
		private var rem:Boolean = false;
		private var tenchange:Boolean = true;
		private var ninechange:Boolean = true;
		private var eightchange:Boolean = true;
		private var sevenchange:Boolean = true;
		private var sixchange:Boolean = true;
		private var fivechange:Boolean = true;
		private var fourchange:Boolean = true;
		private var threechange:Boolean = true;
		private var twochange:Boolean = true;
		private var onechange:Boolean = true;
		public function Hearts(x:Number, y:Number) 
		{
			setupSpritesheet();
			graphic = oneSpritemap;
			oneSpritemap.play(curAnimation);
			setHitbox(8, 8,-10,-10);
			type = "hearts";
			layer = -40;
			super(x, y);
		}
		override public function update():void
		{
			super.update();
			oneSpritemap.play(curAnimation);
			if (tenchange) {
				tenchange = false;
				new Sfx(Assets.SOFTCLICK).play();
			}
			if (PlayerOne.health <= 1000 && PlayerOne.health > 900) {
				curAnimation = "ten";
				if (tenchange) {tenchange = false;new Sfx(Assets.SOFTCLICK).play();}
			}
			if (PlayerOne.health <= 900 && PlayerOne.health > 800) {
				if (ninechange) {ninechange = false;new Sfx(Assets.SOFTCLICK).play();}
				curAnimation = "nine";
			}
			if (PlayerOne.health <= 800 && PlayerOne.health > 700) {
				if (eightchange) {eightchange = false;new Sfx(Assets.SOFTCLICK).play();}
				curAnimation = "eight";
			}
			if (PlayerOne.health <= 700 && PlayerOne.health > 600) {
				if (sevenchange) {sevenchange = false;new Sfx(Assets.SOFTCLICK).play();}
				curAnimation = "seven";
			}
			if (PlayerOne.health <= 600 && PlayerOne.health > 500) {
				if (sixchange) {sixchange = false;new Sfx(Assets.SOFTCLICK).play();}
				curAnimation = "six";
			}
			if (PlayerOne.health <= 500 && PlayerOne.health > 400) {
				if (fivechange) {fivechange = false;new Sfx(Assets.SOFTCLICK).play();}
				curAnimation = "five";
			}
			if (PlayerOne.health <= 400 && PlayerOne.health > 300) {
				if (fourchange) {fourchange = false;new Sfx(Assets.SOFTCLICK).play();}
				curAnimation = "four";
			}
			if (PlayerOne.health <= 300 && PlayerOne.health > 200) {
				if (threechange) {threechange = false;new Sfx(Assets.SOFTCLICK).play();}
				curAnimation = "three";
			}
			if (PlayerOne.health <= 200 && PlayerOne.health > 100) {
				if (twochange) {twochange = false;new Sfx(Assets.SOFTCLICK).play();}
				curAnimation = "two";
			}
			if (PlayerOne.health <= 100 && PlayerOne.health > 0) {
				if (onechange) {onechange = false;new Sfx(Assets.SOFTCLICK).play();}
				curAnimation = "one";
			}
			if (PlayerOne.health <= 0)
				destroy();
		}
		public function setupSpritesheet():void
		{
			oneSpritemap.add("one", [9,10,11], 4, true);
			oneSpritemap.add("two", [8], 0, false);
			oneSpritemap.add("three", [7], 0, false);
			oneSpritemap.add("four", [6], 0, false);
			oneSpritemap.add("five", [5], 0, false);
			oneSpritemap.add("six", [4], 0, false);
			oneSpritemap.add("seven", [3], 0, false);
			oneSpritemap.add("eight", [2], 0, false);
			oneSpritemap.add("nine", [1], 0, false);
			oneSpritemap.add("ten", [0], 0, false);
		}
		public function destroy():void
		{
			FP.world.remove(this);
		}
		
	}

}