package utilities 
{
	import net.flashpunk.FP;
	import player.PlayerOne;
	import ui.Hearts;
	/**
	 * ...
	 * @author Commanderstitch
	 */
	public class Camera 
	{
		private var cameraOffset:Number;
		private var cameraSpeed:Number;
		
		public function Camera(_cameraOffset:Number, _cameraSpeed:Number) 
		{
			cameraOffset = _cameraOffset;
			cameraSpeed = _cameraSpeed;
		}
		public function adjustToPlayer(mapWidth:int, mapHeight:int, playerX:Number, playerY:Number, player:PlayerOne):void
		{
			//find coordinates that center on the player.
			var newCameraX:Number = playerX - FP.width / 2;
			var newCameraY:Number = playerY - FP.height / 2;
			
			//check if they go beyond map boundaries
			if (newCameraX < 0) newCameraX = 0;
			else if (newCameraY + FP.height > mapHeight) newCameraY = mapHeight - FP.height;
			
			//set the camera coordinates
			FP.camera.x = newCameraX;
			FP.camera.y = newCameraY;
			
		}
		
		public function followPlayer(mapWidth:int, mapHeight:int, playerX:Number, playerY:Number):void 
		{
			if (cameraSpeed != PlayerOne.speed) cameraSpeed = PlayerOne.speed;
			//check horizontal axis
			if (playerX - FP.camera.x < cameraOffset+130) 
			{
				//only if the screen's left edge didn't hit the left most boundary x=0;
				if (FP.camera.x > 0) {
					FP.camera.x -= cameraSpeed;
				}
			}
			else if ((FP.camera.x + FP.width) - playerX < cameraOffset)
			{
				//only if hte screen's right edge didn't hit the right most boundry x=mapwidth
				if (FP.camera.x + FP.width < mapWidth) {
					FP.camera.x += cameraSpeed;
				}
			}
			
			//check vertical axis
			if (playerY - FP.camera.y < cameraOffset)
			{
				//only if the screen's upper edge didn't hit the up most boundary y = 0;
				if (FP.camera.y > 0) {
					FP.camera.y -= cameraSpeed;
				}
			}
			else if ((FP.camera.y + FP.height) - playerY < cameraOffset)
			{
				//only if the screen's bottom edge iddn't hit the bottom most boundary x = mapheight
				if (FP.camera.y + FP.height < mapHeight) {
					FP.camera.y += cameraSpeed;
				}
			}
		}
		
	}

}