package worlds 
{
	import doors.BlueThrone;
	import enemies.GreenSpider;
	import enemies.RedSpider;
	import enemies.BrownSpider;
	import enemies.BlueSpider;
	import flash.display.BitmapData;
	import flash.geom.Rectangle;
	import items.BlueBulletPowerUp;
	import items.BombPowerUp;
	import items.GreenBulletPowerUp;
	import net.flashpunk.graphics.Emitter;
	import net.flashpunk.World;
	import player.PlayerOne;
	import ui.BracketSelector;
	import ui.BulletSelect;
	import ui.Clips;
	import ui.Hearts;
	import utilities.Camera;
	import net.flashpunk.FP;
	import net.flashpunk.utils.*;
	import utilities.Weapon;
	/**
	 * ...
	 * @author Commanderstitch
	 */
	public class BlueRoom extends World
	{
		public static var hero:PlayerOne;
		public static var heart:Hearts;
		public static var bulsel:BulletSelect;
		//for me
		public const WIDTH:int = 1102;
		public const HEIGHT:int = 720;
		//camera
		public var cam:Camera
		public var mapWidth:Number = 1472;
		public var mapHeight:Number = 960;
		//emmiter stuff for this world! (level, room, whatever...)
		public static const EXPLOSION:String = "explosion";
		public static const HIT:String = "hit";
		public static const TRAIL:String = "trail";
		public static const GTRAIL:String = "gtrail";
		public static const MISS:String = "miss";
		public static const DMISS:String = "dmiss";
		public static const FLOW:String = "flow";
		public static const CTRAIL:String = "CTRAIL";
		public static var _emitter:Emitter;
		private var togglepause:Boolean = true;
		private var addone:Boolean = true;//this is so when you pause the game you don't add a more than one screen.
		private var w:Number = 0; //random width
		private var h:Number = 0; //random height
		
		public function BlueRoom() 
		{
			//add(new NewMouse(Assets.Hand, true));
			add(new BlueRoomLoader);
			add(hero = new PlayerOne(8, mapHeight/2));
			add(heart = new Hearts(8, 8));
			add(bulsel = new BulletSelect(9, 9));
			add(new BracketSelector(100, 100));
			add(new Clips(8, 224));
			add(new BlueThrone(mapWidth / 2, mapHeight / 2));
			//add new mob...?
			for (var i:int = 0; i < 100; i++) {
				h = rnh(); w = rnw();
				add(new BlueSpider(FP.clamp(w, 16, 1457), FP.clamp(h, 16, 936)));
			}
			cam = new Camera(115, PlayerOne.speed);
			cam.adjustToPlayer(mapWidth, mapHeight, hero.x, hero.y, hero);			
			Input.define("test", Key.T);
			Input.define("mouselocation", Key.M);
		}
		override public function begin():void
		{
			var bd:BitmapData = new BitmapData(5, 1, true, 0);
			bd.setPixel32(1, 1, 0xfffffff);//7 fs?
			bd.fillRect(new Rectangle(3, 0, 3, 3), 0xfffffff);//7fs?
			_emitter = new Emitter(bd, 3, 3);
			_emitter.relative = false;
			_emitter.newType(EXPLOSION, [1]);
			_emitter.setMotion(EXPLOSION, 0, 10, 0.5, 360, 25, 0.5);
			_emitter.setColor(EXPLOSION, 0xfff200, 0xf26522);
			_emitter.newType(HIT, [1]);
			_emitter.setMotion(HIT, 0, 10, 0.5, 360, 15, 0.5);
			_emitter.setColor(HIT, 0x828200, 0x720000);
			_emitter.newType(MISS, [1]);
			_emitter.setMotion(MISS, 0, 5, 0.2, 360, 2, .01);
			_emitter.setColor(MISS, 0xffffff, 0x000000);
			_emitter.newType(DMISS, [1]);
			_emitter.setMotion(DMISS, 0, 5, 0.2, 360, 2, 0.1);
			_emitter.setColor(DMISS, 0x000000, 0xffffff);
			_emitter.newType(TRAIL, [1]);
			_emitter.setMotion(TRAIL,0, 5, 1, 360, 5, 0.25);
			_emitter.setAlpha(TRAIL, 0.8, 0);
			_emitter.setColor(TRAIL, 0xFF0000, 0xA80707);
			_emitter.newType(GTRAIL, [1]);
			_emitter.setMotion(GTRAIL, 0, 5, 1, 360, 5, 0.25);
			_emitter.setAlpha(GTRAIL, 0.8, 0);
			_emitter.setColor(GTRAIL, 0x25FE08, 0x1B8C11);
			addGraphic(_emitter);
			super.begin();
		}
		override public function update():void 
		{
			if (Global.pausegame)
			{
				pauseGame();
			}
			else
				playGame();
		}
		public function playGame():void
		{
			if (Input.pressed(Key.ESCAPE)){ 
				if (togglepause) {
					togglepause = false;
					Global.pausegame = true;
				}
				else {
					togglepause = true;
					Global.pausegame = false;
				}
			}
			if (Input.pressed("test")) {
				//var f:DeathParticle;
				//f = DeathParticle(FP.world.add(newDeathParticle(hero.x +20, hero.y + 30)));
				FP.world.add(new BlueBulletPowerUp(hero.x, hero.y));
				this.emit(EXPLOSION, hero.x, hero.y, 10);	
			}
			if (Input.pressed("mouselocation")) {
				add(new GreenBulletPowerUp(hero.x, hero.y));
				trace(mouseX); trace(mouseY);
			}
			if (Input.pressed(Key.P)) PlayerOne.speed += 2;//testing of course...
			//camera
			cam.followPlayer(mapWidth, mapHeight, hero.x + 100, hero.y + 50);
			heart.y = FP.camera.y;
			heart.x = FP.camera.x;
			bulsel.x = FP.camera.x + 16;
			bulsel.y = FP.camera.y + 232;
			super.update();
		}
		public function emit(type:String, x:int, y:int, size:uint):void
		{
			var i:uint;
			for (i = 0; i < size; i++) {
				_emitter.emit(type, x, y);
			}
		}
		public function pauseGame():void
		{
			if (addone) {
				addone = false;
				trace("here is the pause menu");
				//add one...
				togglepause = true;
				Global.pausegame = false;
			}
			super.update();
		}
		public function rnw():int
		{
			return w = Math.floor(Math.random() * 1457) + 1;
		}
		public function rnh():int
		{
			return h = Math.floor(Math.random() * 936) + 1;
		}
	}
}